using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.AI;

public class waveSpawner : MonoBehaviour
{
    public int waveCounter = 1;
    
    private float multiplier = 1.5f;

    public enum Spawnstate {SPAWNING, WAITING, COUNTING }
    
    [System.Serializable]
    public class Wave
    {
        public string name;
        //public Transform enemy;
        public List<GameObject> objsToSpawn = new List<GameObject>();
        public int enemyAmount;
        public float rate;
    }

    public Wave[] waves;
    private int nextWave = 0;

    public List<GameObject> spawnpoints;

    public bool isRandomized;
    public float delayBetweenWaves = 5f;
    public float waveCountdown;

    public List<GameObject> spawnEffects;
    private ParticleSystem effect;
    public AudioClip soundEffect;

    private float searchCountdown = 1f;

    public Spawnstate state = Spawnstate.COUNTING;
    private void Start()
    {
        waveCountdown = delayBetweenWaves;
        //spawnpoints[spawnpoints.Count] = GameObject.Find("Game");
    }

    private void Update()
    {
        if(state == Spawnstate.WAITING)
        {
            // check if there are enemies alive
            if (!enemyIsAlive())
            {
                // start new wave
                waveCounter++;
                waveFinished();
            }
            else
            {
                return;
            }
        }

        if(waveCountdown <= 0)
        {
            if(state != Spawnstate.SPAWNING)
            {
                // add Audioclips or Effects on Spawn
                //AudioSource.PlayClipAtPoint(soundEffect, transform.position);
                //effect = spawnEffects[0].GetComponent<ParticleSystem>();
                //effect.Play();
                //effect = spawnEffects[1].GetComponent<ParticleSystem>();
                //effect.Play();

                if(waveCounter % 2 == 0)
                {
                    multiplier++;
                }

                // start spawning
                StartCoroutine(spawnWave(waves[nextWave]));
            }
        }
        else
        {
            waveCountdown -= Time.deltaTime;
        }
    }

    void waveFinished()
    {
        Debug.Log("Wave Completed");
        
        state = Spawnstate.COUNTING;
        waveCountdown = delayBetweenWaves;

        if(nextWave + 1 > waves.Length - 1)
        {
            // change for infint run
            nextWave = 0;
            Debug.Log("Completed all waves");
            // add multiplier or something else
        }

        nextWave++;

    }
    bool enemyIsAlive()
    {
        searchCountdown -= Time.deltaTime;
        if (searchCountdown <= 0f)
        {
            searchCountdown = 1f;
            if (GameObject.FindGameObjectWithTag("Enemy") == null/*GameObject.FindGameObjectsWithTag("Enemy").Length == 0*/)
            {
                return false;
            }
        }
        return true;
    }


    IEnumerator spawnWave(Wave _wave)
    {
        Debug.Log("Spawning Wave: " + _wave.name);
        state = Spawnstate.SPAWNING;
        // spawn
        for(int i = 0; i < _wave.enemyAmount; i++)
        {
            SpawnEnemy(_wave.objsToSpawn/*_wave.enemy*/);
            yield return new WaitForSeconds(1f / _wave.rate);
        }

        state = Spawnstate.WAITING;  

        yield break;
    }

    void SpawnEnemy(List<GameObject> _objsToSpawn/*Transform _enemy*/)
    {
        int index = isRandomized ? Random.Range(0, _objsToSpawn.Count) : 0;
        int spawnPoint = Random.Range(0, spawnpoints.Count);

        // spawn enemy and 
        Debug.Log("spawning Enemy: " + _objsToSpawn[index].name + " at Spawnpoint: " + spawnPoint +" ,Coord: " + spawnpoints[spawnPoint].transform/*_enemy.name*/);

        //_objsToSpawn[index].GetComponent<NavMeshAgent>().speed = Random.Range(_objsToSpawn[index].GetComponent<NavMeshAgent>().speed, _objsToSpawn[index].GetComponent<NavMeshAgent>().speed * multiplier);
        //_objsToSpawn[index].GetComponent<NavMeshAgent>().acceleration =Random.Range(_objsToSpawn[index].GetComponent<NavMeshAgent>().acceleration, _objsToSpawn[index].GetComponent<NavMeshAgent>().acceleration * multiplier);
        
        Instantiate(_objsToSpawn[index]/*_enemy*/, spawnpoints[spawnPoint].transform.position, transform.rotation);
        
    }
}
